searchData={"items":[{"type":"module","title":"Waffle.Storage.Google.CloudStorage","doc":"The main storage integration for Waffle, this acts primarily as a wrapper\naround `Google.Api.Storage.V1`. To use this module with Waffle, simply set\nyour `:storage` config appropriately:\n\n```elixir\nconfig :waffle, storage: Waffle.Storage.Google.CloudStorage\n```\n\nEnsure you have a valid bucket set, either through the configs or as an\nenvironment variable, otherwise all calls will fail. The credentials available\nthrough `Goth` must have the appropriate level of access to the bucket,\notherwise some (or all) calls may fail.","ref":"Waffle.Storage.Google.CloudStorage.html"},{"type":"function","title":"Waffle.Storage.Google.CloudStorage.bucket/1","doc":"Returns the bucket for file uploads.","ref":"Waffle.Storage.Google.CloudStorage.html#bucket/1"},{"type":"function","title":"Waffle.Storage.Google.CloudStorage.conn/1","doc":"Constructs a new connection object with scoped authentication. If no scope is\nprovided, the `devstorage.full_control` scope is used as a default.","ref":"Waffle.Storage.Google.CloudStorage.html#conn/1"},{"type":"function","title":"Waffle.Storage.Google.CloudStorage.delete/3","doc":"Delete a file from a Google Cloud Storage bucket.","ref":"Waffle.Storage.Google.CloudStorage.html#delete/3"},{"type":"function","title":"Waffle.Storage.Google.CloudStorage.fullname/3","doc":"A wrapper for `Waffle.Definition.Versioning.resolve_file_name/3`.","ref":"Waffle.Storage.Google.CloudStorage.html#fullname/3"},{"type":"function","title":"Waffle.Storage.Google.CloudStorage.path_for/3","doc":"Returns the full file path for the upload destination.","ref":"Waffle.Storage.Google.CloudStorage.html#path_for/3"},{"type":"function","title":"Waffle.Storage.Google.CloudStorage.put/3","doc":"Put a Waffle file in a Google Cloud Storage bucket.","ref":"Waffle.Storage.Google.CloudStorage.html#put/3"},{"type":"function","title":"Waffle.Storage.Google.CloudStorage.storage_dir/3","doc":"Returns the storage directory **within a bucket** to store the file under.","ref":"Waffle.Storage.Google.CloudStorage.html#storage_dir/3"},{"type":"function","title":"Waffle.Storage.Google.CloudStorage.url/4","doc":"Retrieve the public URL for a file in a Google Cloud Storage bucket. Uses\n`Waffle.Storage.Google.UrlV2` by default, which uses v2 signing if a signed\nURL is requested, but this can be overriden in the options list or in the\napplication configs by setting `:url_builder` to any module that imlements the\nbehavior of `Waffle.Storage.Google.Url`.","ref":"Waffle.Storage.Google.CloudStorage.html#url/4"},{"type":"type","title":"Waffle.Storage.Google.CloudStorage.object_or_error/0","doc":"","ref":"Waffle.Storage.Google.CloudStorage.html#t:object_or_error/0"},{"type":"module","title":"Waffle.Storage.Google.Token.DefaultFetcher","doc":"","ref":"Waffle.Storage.Google.Token.DefaultFetcher.html"},{"type":"behaviour","title":"Waffle.Storage.Google.Token.Fetcher","doc":"","ref":"Waffle.Storage.Google.Token.Fetcher.html"},{"type":"callback","title":"Waffle.Storage.Google.Token.Fetcher.get_token/1","doc":"","ref":"Waffle.Storage.Google.Token.Fetcher.html#c:get_token/1"},{"type":"behaviour","title":"Waffle.Storage.Google.Url","doc":"Defines an interface for generating Google Cloud Storage URLs.","ref":"Waffle.Storage.Google.Url.html"},{"type":"callback","title":"Waffle.Storage.Google.Url.build/4","doc":"Constructs a URL based on data from Waffle.","ref":"Waffle.Storage.Google.Url.html#c:build/4"},{"type":"module","title":"Waffle.Storage.Google.UrlV2","doc":"This is an implementation of the v2 URL signing for Google Cloud Storage. See\n[the Google documentation](https://cloud.google.com/storage/docs/access-control/signed-urls-v2)\nfor more details.\n\nThe bulk of the major logic is taken from Martide's `arc_gcs` work:\nhttps://github.com/martide/arc_gcs.","ref":"Waffle.Storage.Google.UrlV2.html"},{"type":"function","title":"Waffle.Storage.Google.UrlV2.build/3","doc":"Same as `build(definition, version, meta, [])`.","ref":"Waffle.Storage.Google.UrlV2.html#build/3"},{"type":"function","title":"Waffle.Storage.Google.UrlV2.endpoint/1","doc":"Returns the remote asset host. The config key is assumed to be `:asset_host`.","ref":"Waffle.Storage.Google.UrlV2.html#endpoint/1"},{"type":"function","title":"Waffle.Storage.Google.UrlV2.expiry/1","doc":"Returns the amount of time, in seconds, before a signed URL becomes invalid.\nAssumes the key for the option is `:expires_in`.","ref":"Waffle.Storage.Google.UrlV2.html#expiry/1"},{"type":"function","title":"Waffle.Storage.Google.UrlV2.sign_request/1","doc":"","ref":"Waffle.Storage.Google.UrlV2.html#sign_request/1"},{"type":"function","title":"Waffle.Storage.Google.UrlV2.signed?/1","doc":"Determines whether or not the URL should be signed. Assumes the key for the\noption is `:signed`.","ref":"Waffle.Storage.Google.UrlV2.html#signed?/1"},{"type":"module","title":"Waffle.Storage.Google.Util","doc":"A collection of utility functions.","ref":"Waffle.Storage.Google.Util.html"},{"type":"function","title":"Waffle.Storage.Google.Util.option/3","doc":"Attempts to return a value from a given options list, using the application\nconfigs as a back-up. The application (used in `Application.get_env/3`) is\nassumed to be `:waffle`.\n\nThis assumes that the application environment is set using `waffle` as the\napplication name.\n\nIf the value is not found in any of those location, an optional default value\ncan be returned.","ref":"Waffle.Storage.Google.Util.html#option/3"},{"type":"function","title":"Waffle.Storage.Google.Util.prepend_slash/1","doc":"If the given string does not already start with a forward slash, this function\nwill prepend one and return the result.","ref":"Waffle.Storage.Google.Util.html#prepend_slash/1"},{"type":"function","title":"Examples - Waffle.Storage.Google.Util.prepend_slash/1","doc":"> prepend_slash(\"some/path\")\n    \"/some/path\"\n\n    > prepend_slash(\"/im/good\")\n    \"/im/good\"","ref":"Waffle.Storage.Google.Util.html#prepend_slash/1-examples"},{"type":"function","title":"Waffle.Storage.Google.Util.storage_objects_insert/4","doc":"The function `Objects.storage_objects_insert/4` has the wrong URL and will\nalways fail to perform an upload. Because these clients are automatically\ngenerated, there needs to be an investigation as to why this URL is being\nincorrectly set before a solution can be applied. This version of the function\nis an exact copy/paste of the official function except that it uses the\ncorrect upload URL.","ref":"Waffle.Storage.Google.Util.html#storage_objects_insert/4"},{"type":"function","title":"Waffle.Storage.Google.Util.var/1","doc":"Accepts four forms of variables:\n\n1. The tuple `{:system, key}`, which uses `System.get_env/1`.\n2. The tuple `{:app, key}`, which uses `Application.get_env/2`.\n3. The tuple `{:app, app, key}`, which usees `Application.get_env/2`.\n4. Anything else which is returned as-is.\n\nIn the second form (`{:app, key}`), the application is assumed to be `:waffle`\nalthough this can be overriden using the third form (`{:app, app, key}`).","ref":"Waffle.Storage.Google.Util.html#var/1"},{"type":"module","title":"Waffle.Types","doc":"This is hack until Waffle declares formal typespecs in its own project.","ref":"Waffle.Types.html"},{"type":"type","title":"Waffle.Types.definition/0","doc":"","ref":"Waffle.Types.html#t:definition/0"},{"type":"type","title":"Waffle.Types.file/0","doc":"","ref":"Waffle.Types.html#t:file/0"},{"type":"type","title":"Waffle.Types.meta/0","doc":"","ref":"Waffle.Types.html#t:meta/0"},{"type":"type","title":"Waffle.Types.version/0","doc":"","ref":"Waffle.Types.html#t:version/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}